﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using System.IO;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Microsoft.AspNetCore.Hosting.Server;
using Microsoft.AspNetCore.Hosting.Internal;
using Microsoft.Extensions.PlatformAbstractions;
using Microsoft.DotNet.InternalAbstractions;
using Microsoft.AspNetCore.Hosting;

namespace Sample.Controllers
{
    public class HomeController : Controller
    {
        private readonly IHostingEnvironment hostingEnvironment;
        public HomeController(IHostingEnvironment hostingEnvironment)
        {
            this.hostingEnvironment = hostingEnvironment;
        }
        public object AppDomain { get; private set; }

        public IActionResult Index()
        {
            return View();
        }

        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Error()
        {
            return View();
        }


        public IActionResult CreatePDF()
        {
            //Creating new PDF document instance
            PdfDocument document = new PdfDocument();

            //Adding a new page
            PdfPage page = document.Pages.Add();

            //Creating font instances
            PdfFont font = new PdfStandardFont(PdfFontFamily.TimesRoman, 35);

            page.Graphics.DrawString("Hello World!", font, PdfBrushes.Black, new Syncfusion.Drawing.PointF(10, 20));

            //Saving the PDF to the MemoryStream
            MemoryStream ms = new MemoryStream();

            ////Save the PDF file in local disk.   

            //string path = hostingEnvironment.ContentRootPath;            
                    
            //document.Save(path +"/output.pdf");

            document.Save(ms);

            //If the position is not set to '0' then the PDF will be empty.
            ms.Position = 0;

            //Download the PDF document in the browser.
            FileStreamResult fileStreamResult = new FileStreamResult(ms, "application/pdf");

            fileStreamResult.FileDownloadName = "Sample.pdf";

            return fileStreamResult;
        }   
             
    }
}
